import React from 'react';
import { useInterval } from './useInterval.mjs';
const DEFAULT_INTERVAL = 5000;
export function usePollReferenceStatus(params) {
    var _a;
    const [data, setData] = React.useState(null);
    const [error, setError] = React.useState(null);
    const [isPolling, setIsPolling] = React.useState(true);
    const cancel = React.useCallback((broadcast = true) => {
        var _a;
        setIsPolling(false);
        if (broadcast) {
            (_a = params === null || params === void 0 ? void 0 : params.onCancel) === null || _a === void 0 ? void 0 : _a.call(params);
        }
    }, [isPolling]);
    const { pollReferenceStatus } = React.useMemo(() => params.bedrock, [params.bedrock]);
    useInterval(async () => {
        var _a, _b;
        try {
            const data = await pollReferenceStatus.status({ ref: params.ref });
            if (data.signature !== null) {
                setData(data);
                (_a = params === null || params === void 0 ? void 0 : params.onComplete) === null || _a === void 0 ? void 0 : _a.call(params, data);
                cancel(false);
            }
        }
        catch (e) {
            console.error(e);
            setError(e);
            (_b = params === null || params === void 0 ? void 0 : params.onError) === null || _b === void 0 ? void 0 : _b.call(params, e);
            cancel(false);
        }
    }, (_a = params.interval) !== null && _a !== void 0 ? _a : DEFAULT_INTERVAL, isPolling);
    return {
        data,
        error,
        cancel,
    };
}
//# sourceMappingURL=usePollReferenceStatus.js.map